﻿@using System.Web.UI.WebControls;
@{
    Layout = "~/Views/Layout/Dashboard.cshtml";
}

<script src="@Url.Content("~/Scripts/jquery.mtz.monthpicker.js")" type="text/javascript"></script>
@section Style{
    .ui-datepicker.ui-corner-all { -moz-border-radius: 4px; -webkit-border-radius: 4px; border-radius: 4px; }
    .iu-widget-header { background-color: #94B6E8; color: #94B6E8; }
    .ui-widget-header {
    background: url("images/ui-bg_highlight-soft_15_cc0000_1x100.png") repeat-x scroll 50% 50% #94B6E8;
    background-color: #DDECFF;
    border: 1px solid #94B6E8;
    color: #94B6E8;
    font-weight: bold;
    }
    div.ui-datepicker {width: 17em; padding: .2em .2em 0;}
    div.ui-datepicker-header.mtz-monthpicker {border: 1px solid #DDECFF; background-color: #DDECFF; color: #DDECFF; font-weight: bold;}
    table.mtz-monthpicker {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
    td.ui-state-default.mtz-monthpicker-month {border: 1px solid #fff;}
    td.ui-state-default.mtz-monthpicker-month {text-align: center; cursor: pointer; padding: 5px;}
    td.ui-state-default.mtz-monthpicker-month:hover, td.ui-state-default.mtz-monthpicker-month-selected {background: none; background-color: #DDECFF; color: #fff; cursor: pointer;}
    td.ui-state-default.mtz-monthpicker-month:hover {background-color: #fff; color: #000;}
    select.mtz-monthpicker-year {margin-top: 7px;}
}

@section Script{
    /*Month Picker*/
    $(document).ready(function() {

    $('#ProdMonth').monthpicker({
    startYear: new Date().getFullYear() - 5,
    finalYear: new Date().getFullYear() + 1,
    pattern: 'mmm yyyy',
    monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
    });

    
    });
}

<script>
    isSearch = "N";

    function pad(n) {
        return (n < 10) && (n >= 0) ? ("0" + n) : n;
    }

    function GetRegularProductionMonth(productionMonth) {
        var year = String(productionMonth).substring(0, 4);
        var month = String(productionMonth).substring(String(productionMonth).length, String(productionMonth).length - 2);
        var monthEnum = {
            '01': 'January',
            '02': 'February',
            '03': 'March',
            '04': 'April',
            '05': 'May',
            '06': 'June',
            '07': 'July',
            '08': 'August',
            '09': 'September',
            '10': 'October',
            '11': 'November',
            '12': 'December'
        };

        return monthEnum[month] + " " + year;
    }

    function GetProductionMonth(productionMonth) {
        var paramStr = String(productionMonth).replace(' ', '');
        var paramStrLength = String(paramStr).length;

        var year = String(paramStr).substring(paramStrLength, paramStrLength - 4);
        var month = String(paramStr).substring(0, paramStrLength - 4);
        var monthEnum = {
            January: '01',
            February: '02',
            March: '03',
            April: '04',
            May: '05',
            June: '06',
            July: '07',
            August: '08',
            September: '09',
            October: '10',
            November: '11',
            December: '12'
        };
        var monthNum = "";
        if (Boolean(month))
            monthNum = monthEnum[month];

        return year + monthNum;
    }

    function onClickSearch()
    {
        isSearch = 'Y';
        if (KeihenTab.GetActiveTabIndex() == 0) {
            UploadKeihenGrid.UnselectAllRowsOnPage();
            UploadKeihenGrid.PerformCallback();
        }
        else if (KeihenTab.GetActiveTabIndex() == 1) {
            CalculatedKeihenGrid.UnselectAllRowsOnPage()
            CalculatedKeihenGrid.PerformCallback();
        }
    }

    function onCLickClear()
    {
        isSearch = "N";
        $("#ProdMonth").val('');
        
        if (KeihenTab.GetActiveTabIndex() == 0)
            UploadKeihenGrid.PerformCallback();
        else if (KeihenTab.GetActiveTabIndex() == 1)
            CalculatedKeihenGrid.PerformCallback();
    }

    function OnTabChanged(s, e)
    {
        onClickSearch();
    }

    function OnBeginCallbackGrid(s, e)
    {
        var ProdMonth = GetProductionMonth($("#ProdMonth").val())

        if (ProdMonth.length <= 0)
            ProdMonth = 'x'

        e.customArgs["PACK_MONTH"] = ProdMonth;
        e.customArgs["isSearch"] = isSearch;
    }

    function OnEndCallbackGrid()
    {

    }

    function OnBeginCallbackCalculatedGrid(s, e) {
        var ProdMonth = GetProductionMonth($("#ProdMonth").val())

        if (ProdMonth.length <= 0)
            ProdMonth = 'x'

        e.customArgs["PACK_MONTH"] = ProdMonth;
        e.customArgs["isSearch"] = isSearch;
    }

    function OnEndCallbackCalculatedGrid() {

    }

    function OnEditClick(PACK_MONTH, REMINDER_START, REMINDER_END)
    {
        $("#EditPackMonth").html(GetRegularProductionMonth(PACK_MONTH));

        //if ((REMINDER_START.trim() != "") && (REMINDER_START.trim() != undefined)
        //    && (REMINDER_END.trim() != "") && (REMINDER_END.trim() != undefined))
        //{
            if (REMINDER_START.split(" ")[0] != "") RemiderStartDate.SetText(REMINDER_START.split(" ")[0]);
            if (REMINDER_END.split(" ")[0] != "") RemiderEndDate.SetText(REMINDER_END.split(" ")[0]);

            $("#ReminderStartTime_I").focus();
            $("#ReminderStartTime_I").val(REMINDER_START.split(" ")[1]);
            //ReminderStartTime.SetText(REMINDER_START.split(" ")[1]);

            
            $("#ReminderEndTime_I").focus();
            $("#ReminderEndTime_I").val(REMINDER_END.split(" ")[1]);
            //ReminderEndTime.SetText(REMINDER_END.split(" ")[1]);
        //}

        popupForm.Show();
    }

    function CancelUpdate()
    {
        var d = new Date();
        RemiderStartDate.SetDate(d);
        RemiderEndDate.SetDate(d);

        ReminderStartTime.SetText("");
        ReminderEndTime.SetText("");
        popupForm.Hide();
    }

    function UpdateReminder()
    {
        var Pack_Month = GetProductionMonth($("#EditPackMonth").html());
        var Reminder_StartDate = RemiderStartDate.GetText();
        var Reminder_StartTime = ReminderStartTime.GetText();
        var Reminder_EndDate = RemiderEndDate.GetText();
        var Reminder_EndTime = ReminderEndTime.GetText();

        if ((Reminder_StartDate == "") && (Reminder_EndDate != "")) {
            $.msgBox({ title: "error", type: "error", content: "If End Date not empty, Please fill the Start Date" });
            return;
        }

        if ((Reminder_StartDate != "") && (Reminder_EndDate == "")) {
            $.msgBox({ title: "error", type: "error", content: "If Start Date not empty, Please fill the End Date" });
            return;
        }

        var StartDateArray = Reminder_StartDate.split('.').reverse();
        var EndDateArray = Reminder_EndDate.split('.').reverse();

        var p = new Date(StartDateArray.join("-") + " " + Reminder_StartTime);
        var q = new Date(EndDateArray.join("-") + " " + Reminder_EndTime);

        if (q <= p)
        {
            $.msgBox({ title: "error", type: "error", content: "End DateTime cannot less than or equal Start DateTime" });
            return;
        }

        var ReminderStartDate_SQL = StartDateArray.join("") + " " + Reminder_StartTime;
        var ReminderEndDate_SQL = EndDateArray.join("") + " " + Reminder_EndTime;

        if (ReminderStartDate_SQL.trim() == "00:00:00"
            || ReminderStartDate_SQL.trim() == ""
            || ReminderStartDate_SQL.trim() == undefined
            || StartDateArray.join("") == ""
            || StartDateArray.join("") == undefined)
            ReminderStartDate_SQL = "";

        if (ReminderEndDate_SQL.trim() == "00:00:00"
            || ReminderEndDate_SQL.trim() == ""
            || ReminderEndDate_SQL.trim() == undefined
            || EndDateArray.join("") == ""
            || EndDateArray.join("") == undefined)
            ReminderEndDate_SQL = "";

        $.ajax({
            type: "POST",
            async: false,
            url: "@Url.Content("~/Keihen/UpdateReminder")",
            data: {
                pack_month: Pack_Month,
                reminder_start: ReminderStartDate_SQL,
                reminder_end: ReminderEndDate_SQL
            },
            success: function (result) {
                if (result == "SUCCESS") {
                    $.msgBox({ title: "info", type: "info", content: "Success Update Reminder" });
                    CancelUpdate();
                    onClickSearch();
                }
                else {
                    $.msgBox({ title: "error", type: "error", content: result });
                }
            },
            error: function (result) {
                $.msgBox({ title: "error", type: "error", content: result });
            }
        });
    }

    function DownloadCalculatedKeihenData(PACK_MONTH) {
        $.fileDownload("Keihen/DownloadCalculatedKeihenData/", {
            data: {
                PACK_MONTH: PACK_MONTH
            },
            successCallback: function (url) {

            },
            failCallback: function (responseHtml, url) {
                $.msgBox({ title: "error", type: "error", content: "Error While Download Data" });
            }
        });
    }

    function DownloadKeihenUploadTemplate()
    {
        $.fileDownload("Keihen/DownloadUploadKeihenTemplate/", {
            data:
            {

            },
            successCallback: function (url) {
            },
            failCallback: function (responseHtml, url) {
                $.msgBox({ title: "error", type: "error", content: "Error While Download Data" });
            }
        });
    }

    function UploadRevision(s, e) {
        LoadingPanel.Show();
        RevisionFileUpload.UploadFile();
    }

    function OnUploadRevisionComplete(s, e)
    {
        if (e.isValid) {
            filePath = e.callbackData;
            $.ajax({
                type: "POST",
                url: "@Url.Content("~/Keihen/RevisionKeihenDataUpload")",
                dataType: "json",
                async: false,
                data: {
                    filePath: filePath
                },
                success: function (result) {
                    var parameterValues = result.Status.split(';');
                    console.log(parameterValues);
                    if (parameterValues[0] == "true") {
                        OnUploadRevisionValid(parameterValues[1]);
                    }
                    else if (parameterValues[0] == "false") {
                        if (parameterValues.length == "3") {
                            LoadingPanel.Hide();
                            $.msgBox({ title: "error", type: "error", content: parameterValues[2] + " [pid : " + parameterValues[1] + "]" });
                        }
                        else {
                            LoadingPanel.Hide();
                            $.msgBox({ title: "error", type: "error", content: "Error Occured, Please See Downloaded Excel File For More Information. [pid : " + parameterValues[1] + "]" });
                            OnUploadRevisionInvalid(parameterValues[1]);
                        }
                    }
                    else if (parameterValues[0] == "empty") {
                        LoadingPanel.Hide();
                        $.msgBox({ title: "error", type: "error", content: "No Data Found in Uploaded Data with Process ID " + parameterValues[1] });
                    }
                },
                error: function (result) {
                    LoadingPanel.Hide();
                    $.msgBox({ title: "error", type: "error", content: "Error On Keihen File Upload." });
                }
            });
        }
    }

    function DownloadKeihenData(s, e)
    {
        var tempName = s.name.substring(9);
        productionMonth = $('#UploadKeihenGrid').find('#UploadKeihenGrid_DXDataRow' + tempName + ' td').filter(':first').html();

        $.fileDownload("Keihen/DownloadKeihenData/", {
            data: {
                PACK_MONTH : productionMonth
            },
            successCallback: function (url) {
                
            },
            failCallback: function (responseHtml, url) {
                $.msgBox({ title: "error", type: "error", content: "Error While Download Data" });
            }
        });
    }

    function UploadData(s, e) {
        LoadingPanel.Show();
        FileUpload.UploadFile();
    }

    function OnUploadComplete(s, e) {
        if (e.isValid) {
            filePath = e.callbackData;
            $.ajax({
                type: "POST",
                url: "@Url.Content("~/Keihen/KeihenDataUpload")",
                dataType: "json",
                async: false,
                data: {
                    filePath: filePath
                },
                success: function (result) {
                    var parameterValues = result.Status.split(';');
                    console.log(parameterValues);
                    if (parameterValues[0] == "true") {
                        OnUploadValid(parameterValues[1]);
                    }
                    else if (parameterValues[0] == "false") {
                        if (parameterValues.length == "3") {
                            LoadingPanel.Hide();
                            $.msgBox({ title: "error", type: "error", content: parameterValues[2] + " [pid : " + parameterValues[1] + "]" });
                        }
                        else {
                            LoadingPanel.Hide();
                            $.msgBox({ title: "error", type: "error", content: "Error Occured, Please See Downloaded Excel File for More Information. [pid : " + parameterValues[1] + "]" });
                            OnUploadInvalid(parameterValues[1]);
                        }
                    }
                    else if (parameterValues[0] == "empty") {
                        LoadingPanel.Hide();
                        $.msgBox({ title: "error", type: "error", content: "No Data Found in Uploaded Data with Process ID " + parameterValues[1] });
                    }
                },
                error: function (result) {
                    LoadingPanel.Hide();
                    $.msgBox({ title: "error", type: "error", content: "Error On Keihen File Upload." });
                }
            });
        }
    }

    function OnUploadRevisionValid(processId) {
        $.ajax({
            type: "POST",
            async: false,
            url: "@Url.Content("~/Keihen/ReviseKeihen")",
            data: {
                processId: processId
                },
            success: function (result) {
                LoadingPanel.Hide();
                if (result === "SUCCESS") {
                    $.msgBox({ title: "info", type: "info", content: "Upload Success" });
                    onClickSearch();
                }
                else if (result.indexOf("(WARNING)") >= 0) {
                    $.msgBox({ title: "warning", type: "warning", content: result.replace("(WARNING) ", "") });
                }
                else {
                    $.msgBox({ title: "error", type: "error", content: result });
                }
            },
            error: function (result) {
                LoadingPanel.Hide();
                $.msgBox({ title: "error", type: "error", content: result });
            }
        });
    }

    function OnUploadValid(processId) {
        $.ajax({
            type: "POST",
            async: false,
            url: "@Url.Content("~/Keihen/CalculateKeihen")",
            data: {
                processId: processId
            },
            success: function (result) {
                LoadingPanel.Hide();
                if (result === "SUCCESS") {
                    $.msgBox({ title: "info", type: "info", content: "Upload Success" });
                    onClickSearch()
                }
                else {
                    $.msgBox({ title: "error", type: "error", content: result });
                }
            },
            error: function (result) {
                LoadingPanel.Hide();
                $.msgBox({ title: "error", type: "error", content: result });
            }
        });
    }

    function OnUploadRevisionInvalid(processId) {
        $.fileDownload("Keihen/DownloadInvalidRevisionKeihenData/", {
            data: {
                process_id: processId,
            },
            successCallback: function (url) {
            },
            failCallback: function (responseHtml, url) {
                $.msgBox({ title: "error", type: "error", content: "Error On Keihen Data File Invalid Download." });
            }
        });
    }

    function OnUploadInvalid(processId) {
        $.fileDownload("Keihen/DownloadInvalidKeihenData/", {
            data: {
                process_id: processId,
            },
            successCallback: function (url) {
            },
            failCallback: function (responseHtml, url) {
                $.msgBox({ title: "error", type: "error", content: "Error On Keihen Data File Invalid Download." });
            }
        });
    }

    function Approve(s, e)
    {
        LoadingPanel.Show();
        if (CalculatedKeihenGrid.GetSelectedRowCount() != 1) {
            $.msgBox({ title: "warning", type: "warning", content: "Please select only one data to be Approved." });
            return;
        }

        var packmonth = "";

        for (var index = CalculatedKeihenGrid.GetTopVisibleIndex() ; index < ((CalculatedKeihenGrid.GetPageIndex() * CalculatedKeihenGrid.cpPageSize) + CalculatedKeihenGrid.GetVisibleRowsOnPage()) ; index++) {
            if (CalculatedKeihenGrid.IsRowSelectedOnPage(index)) {
                packmonth = CalculatedKeihenGrid.cpPackMonth[index - (CalculatedKeihenGrid.GetPageIndex() * CalculatedKeihenGrid.cpPageSize)];
                break;
            }
        }

        $.ajax({
            type: "POST",
            async: false,
            url: "@Url.Content("~/Keihen/ApproveKeihen")",
            data: {
                pack_month : packmonth
            },
            success: function (result) {
                LoadingPanel.Hide();
                if (result === "SUCCESS") {
                    $.msgBox({ title: "info", type: "info", content: "Approval Success" });
                    onClickSearch();
                }
                else if (result.indexOf("(WARNING)") >= 0) {
                    $.msgBox({ title: "warning", type: "warning", content: result.replace("(WARNING) ", "") });
                    onClickSearch();
                }
                else {
                    $.msgBox({ title: "error", type: "error", content: result });
                }
            },
            error: function (result) {
                LoadingPanel.Hide();
                $.msgBox({ title: "error", type: "error", content: result });
            }
        });
    }
</script>

<div style="border:1px solid #142B94; background-color:#DEECFD; padding:10px; width:60%;margin-bottom:20px;">
    <table border="0" style="vertical-align:middle; padding-bottom:6px;width:100%">
        <tr>
            <td style="padding-bottom: 6px; width: 20%">
                Production Month
            </td>
            <td style="padding-left: 6px; padding-bottom: 6px; width: 20%">
                <input type="text" id='ProdMonth' name="ProdMonth" class="mtz-monthpicker-widgetcontainer" style="width:250px; font-size:small;" />
            </td>
            <td style="width:50%"></td>
            <td style="padding-left:6px; padding-bottom:6px;width:20%">
                <table border="0" style="width:100%;float:right">
                    <tr>
                        <td style="width:40%">&nbsp&nbsp&nbsp&nbsp&nbsp</td>
                        <td style="width:30%">
                            @Html.DevExpress().Button(
                        settings =>
                        {
                            settings.Name = "DJSearchButton";
                            settings.Text = "Search";
                            settings.UseSubmitBehavior = true;
                            settings.Width = Unit.Pixel(80);
                            settings.ClientSideEvents.Click = "onClickSearch";
                        }).GetHtml()
                        </td>
                        <td style="width:30%">
                            @Html.DevExpress().Button(
                        settings =>
                        {
                            settings.Name = "DJClearButton";
                            settings.Text = "Clear";
                            settings.UseSubmitBehavior = true;
                            settings.Width = Unit.Pixel(80);
                            settings.ClientSideEvents.Click = "onCLickClear";
                        }).GetHtml()
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
    </table>
</div>

@Html.DevExpress().PageControl(
settings =>
{
    settings.Name = "KeihenTab";
    settings.Width = Unit.Percentage(100);
    settings.ClientSideEvents.ActiveTabChanged = "OnTabChanged";
    settings.TabPages.Add("Consolidation").SetContent(() =>
    {
        Html.RenderAction("UploadKeihenTab", "Keihen");
    });

    settings.TabPages.Add("Validation").SetContent(() =>
    {
        Html.RenderAction("CalculatedKeihenTab", "Keihen");
    });
}).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Name = "popupForm";
    settings.HeaderText = "Edit Reminder";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(400);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(10);
    settings.AllowDragging = false;
    settings.CloseAction = CloseAction.None;
    settings.ShowCloseButton = false;
    settings.SetContent(() =>
    {
        Html.RenderPartial("PartialPopupEditReminder");
    });
}).GetHtml()

@Html.DevExpress().LoadingPanel(
settings =>
{
    settings.Name = "LoadingPanel";
    settings.Modal = true;
    //settings.ContainerElementID = IsDisplayedOverPanel ? "Panel" : "";
}).GetHtml()